#include "monitor.h"

int
mon_enter(monitor_t *mon)
{
	LOCK(mon);
	return 0;
}

int
mon_exit(monitor_t *mon)
{
	UNLOCK(mon);
	return 0;
}

int
mon_signal(monitor_t *mon, int cond)
{
	mon->state = 1;
	mon->cond = cond;
	mon_exit(mon);
	mon_enter(mon);
	mon->state = 0;
	return 0;
}

int
mon_wait(monitor_t *mon, int cond)
{
	while (1) {
		mon_exit(mon);
		mon_enter(mon);
		if (mon->state && cond == mon->cond)
			return 0;
	}
}
