
#include "rendezvous.h"

int
init_rendezvous(rendez *r)
{
	INITLOCK(r);
	r->data = 0;
	sem_init(&r->wait, 0, 0);
	return 0;
}


int
rendezvous(rendez *r, unsigned *p)
{
	LOCK(r);
	if (r->data == 0) {
		r->data = p;
		UNLOCK(r);
		sem_wait(&r->wait);
		return 0;
	} else {
		unsigned       x = *p;
		*p = *r->data;
		*r->data = x;
		r->data = 0;   /* clear rendezvous */
		UNLOCK(r);
		sem_post(&r->wait);
		return 1;
	}
}
