#ifndef _rwlock_h
#define _rwlock_h


#ifndef _SEMAPHORE_H_INCLUDED
#include <semaphore.h>
#endif

#ifndef _lock_h
#include "lock.h"
#endif

typedef struct rwlock rwlock_t;
struct rwlock {
	LOCKSTRUCT;
	int          nreaders;
	int          nwriters;
	int          waitingreaders;
	int          waitingwriters;
	sem_t        readwait;
	sem_t        writewait;
};


extern int init_rwlock(rwlock_t *);
extern int read_lock(volatile rwlock_t *);
extern int read_unlock(volatile rwlock_t *);
extern int write_lock(volatile rwlock_t *);
extern int write_unlock(volatile rwlock_t *);


#endif
